//
//  AsyncDispatchAppDelegate.m
//  AsyncDispatch
//
//  Created by ampatspell on 7/23/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "AsyncDispatchAppDelegate.h"
#import "ZRModelStateToNSStringValueTransformer.h"
#import "ZRSession.h"
#import "ZRPerson.h"
#import "ZRMessage.h"


@interface AsyncDispatchAppDelegate ()
@end

@implementation AsyncDispatchAppDelegate
@synthesize window, session, messages;

+ (void)initialize
{
  [NSValueTransformer setValueTransformer:[[[ZRModelStateToNSStringValueTransformer alloc] init] autorelease] 
                                  forName:@"ZRModelStateString"];
}

- (ZRSession *)createSessionWithDefaultCredentials
{
  ZRSession *sess = [dispatch modelForClass:[ZRSession class]];
  sess.login = @"ampatspell";
  sess.password = @"freak";
  return sess;
}

- (void)applicationDidFinishLaunching:(NSNotification *)notification
{
  NSString *url = @"http://zero-edit.appspot.com/rpc";
  //  NSString *url = @"http://localhost:8080/rpc";
  dispatch = [[ZRAsyncDispatch alloc] initWithURL:[NSURL URLWithString:url]];
  dispatch.delegate = self;
  
  self.session = [self createSessionWithDefaultCredentials];
}

- (IBAction)login:(id)sender
{
  [session commitWithTarget:self success:@selector(_loginDidSucceed:) failed:@selector(_loginDidFail:)];
}

- (void)_loginDidSucceed:(ZRSession *)sess
{
  NSLog(@"%@ %s %@", [self className], _cmd, session);
  
}

- (void)_loginDidFail:(ZRSession *)sess
{
  NSLog(@"%@ %s %@", [self className], _cmd, session.error);
}

- (IBAction)logout:(id)sender
{
  [session destroyWithTarget:self success:@selector(_logoutDidSucceed:) failed:nil];
}

- (void)_logoutDidSucceed:(ZRSession *)sess
{
  self.session = [self createSessionWithDefaultCredentials];
}

#pragma mark -

- (IBAction)fetchMessages:(id)sender
{
  if(!messages) {
    self.messages = [dispatch arrayForClass:[ZRMessage class] withQuery:ZRQueryKindAll];    
  }
  [messages fetch];
}

- (IBAction)reloadMessages:(id)sender
{
  if(!messages) {
    self.messages = [dispatch arrayForClass:[ZRMessage class] withQuery:ZRQueryKindAll];    
  }
  [messages reload];  
}

#pragma mark -

- (void)asyncDispatch:(ZRAsyncDispatch *)aDispatch didCreateModelInstance:(id)model
{
  [model setDispatch:aDispatch];
}

- (void)asyncDispatch:(ZRAsyncDispatch *)dispatch didCreateModelArrayInstance:(id)array
{
  NSLog(@"%@ %s", [self className], _cmd);
}

- (NSDictionary *)asyncDispatchAdditionalParameters:(ZRAsyncDispatch *)aDispatch
{
  return [NSDictionary dictionaryWithObjectsAndKeys:
          session.key, @"token",
          nil];  
}

- (BOOL)asyncDispatch:(ZRAsyncDispatch *)dispatch shouldRetryOperation:(ZROperation *)operation withError:(NSError *)error
{
  return operation.retryCount < 5;
}

@end
