import rpc
from rpc import require_user
from google.appengine.ext import db
from models import Message, Count

class MessageNamespace(rpc.Namespace):
  
  @require_user
  def all(self):
    cursor = self.request.get("cursor")
    count = self.request["count"]
    messages = Message.all().order("index").with_cursor(cursor)
    self.response["data"]  = [message.to_json() for message in messages.fetch(limit=count)]
    self.response["cursor"] = messages.cursor()
  
  def count(self):
    self.response["count"] = Count.get_value("message")
  
  @require_user
  def batch_create(self):
    count = int(self.request["count"])
    
    start = 0
    last = Message.all().order("-index").fetch(limit=1)
    if last:
      start = last[0].index + 1
        
    keys = db.put([Message(body = ("Message %i" % (start + index)), index=(start+index)) for index in range(count)])
    Count.increment_value("message", count)
    
    self.response = [str(key) for key in keys]
