import rpc
from rpc import require_user
from google.appengine.ext import db
from models import Person, Project
from utils import string_sha1

class ProjectNamespace(rpc.Namespace):
  
  def all(self):
    self.response = []
    for project in Project.all():
      self.response.append(project.to_json())
     
  @require_user
  def create(self):
    name = self.request.get("name")
    owner = self.current_user_key()
    
    key = Project(name=name, owner=owner).put()
    
    self.response["key"] = str(key)

  def update(self):
    name = self.request.get("name")
    key = self.request.get("key")
    
    def tx(key, name):
      project = Project.get(key)
      project.name = name
      project.put()
      
    db.run_in_transaction(tx, db.Key(encoded=key), name)

  def destroy(self):
    project = Project.get(db.Key(encoded=self.request.get("key")))
    if project:
      project.delete()
