//
//  ZRAsync.h
//  ZeroEdit
//
//  Created by ampatspell on 6/4/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "ZRRPCOperation.h"

#define ZR_ASYNC_DEBUG

extern NSString *const ZRAsyncDidBecomeBusyNotification;
extern NSString *const ZRAsyncDidBecomeIdleNotification;

extern NSString *const ZRAsyncErrorDomain;
extern NSInteger const ZRAsyncRequestFailedErrorCode;

typedef NSString *ZRAsyncRequestID;
extern ZRAsyncRequestID const ZRNilAsyncRequestID;


@protocol ZRAsyncDelegate;

@interface ZRAsync : NSObject <ZRRPCOperationDelegate> {
  NSMutableDictionary *operations;
  id<ZRAsyncDelegate> delegate;
}

- (id)init;
- (id)initWithDelegate:(id<ZRAsyncDelegate>)delegate;

@property(nonatomic, readwrite, assign) id<ZRAsyncDelegate> delegate;

- (ZRAsyncRequestID)executeWithURL:(NSURL *)url
                        parameters:(NSDictionary *)parameters 
                          userInfo:(id)userInfo;

- (void)cancel:(ZRAsyncRequestID)requestId;
- (void)cancelAll;

@end


@protocol ZRAsyncDelegate
- (void)async:(ZRAsync *)async operationDidSucceedWithResult:(id)result userInfo:(id)userInfo;
- (void)async:(ZRAsync *)async operationDidFailWithError:(NSError *)error userInfo:(id)userInfo;
@end
