//
//  ZRAsyncDispatch.h
//  AsyncDispatch
//
//  Created by ampatspell on 7/23/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "ZRModel.h"
#import "ZRModelArray.h"
#import "ZRAsync.h"


@protocol ZRAsyncDispatchDelegate;

@interface ZRAsyncDispatch : NSObject <ZRAsyncDelegate, ZRModelDelegate, ZRModelArrayDelegate> {
  NSURL *url;
  ZRAsync *async;
  id<ZRAsyncDispatchDelegate> delegate;
}

- (id)initWithURL:(NSURL *)url;

@property(nonatomic, readwrite, copy) NSURL *url;
@property(nonatomic, readwrite, assign) id<ZRAsyncDispatchDelegate> delegate;

- (id)modelForClass:(Class)modelClass;
- (id)modelForClass:(Class)modelClass withKey:(NSString *)key;

- (id)arrayForClass:(Class)modelClass withQuery:(ZRQueryKind)kind;
- (id)arrayForClass:(Class)modelClass withQuery:(ZRQueryKind)kind parameters:(NSDictionary *)params;

@end

@protocol ZRAsyncDispatchDelegate <NSObject>
@optional
- (void)asyncDispatch:(ZRAsyncDispatch *)dispatch didCreateModelInstance:(id)model;
- (void)asyncDispatch:(ZRAsyncDispatch *)dispatch didCreateModelArrayInstance:(id)array;
- (NSDictionary *)asyncDispatchAdditionalParameters:(ZRAsyncDispatch *)dispatch;
- (BOOL)asyncDispatch:(ZRAsyncDispatch *)dispatch shouldRetryOperation:(ZROperation *)operation withError:(NSError *)error;
@end
