//
//  ZRDynamicModelGlobalSettings.m
//  AsyncDispatch
//
//  Created by ampatspell on 7/24/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ZRConfiguration.h"
#import "ZRSingletonBoilerplate.h"
#import "ZRModelConfiguration.h"


@interface ZRConfiguration ()
@property(nonatomic, readwrite, retain) NSMutableDictionary *classes;
@end


@implementation ZRConfiguration
ZR_SINGLETON_BOILERPLATE(ZRConfiguration, sharedConfiguration)

@synthesize classes;

- (id)init
{
  if(self = [super init]) {
    classes = [[NSMutableDictionary alloc] init];
  }
  return self;
}

- (ZRModelConfiguration *)modelConfigurationForClass:(Class)modelClass
{
  ZRModelConfiguration *instance = [classes objectForKey:modelClass];
  if(!instance) {
    ZRModelConfiguration *superclassConfiguration = nil;
    Class superclass = [modelClass superclass];
    if(superclass && superclass != [NSObject class]) {
      superclassConfiguration = [self modelConfigurationForClass:superclass];
    }
    
    instance = [[[ZRModelConfiguration alloc] initWithModelClass:modelClass 
                                         superclassConfiguration:superclassConfiguration] autorelease];
    [classes setObject:instance forKey:modelClass];
  }
  
  return instance;
}

@end
