//
//  ZRMethodImplementationType.m
//  modelsframework
//
//  Created by ampatspell on 6/27/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ZRMethodImplementationType.h"
#import <objc/runtime.h>


ZRMethodImplementationType ZRClassMethodImplementationType(Class class, SEL selector) {
  Method method = class_getClassMethod(class, selector);
  if(method) {
    Class superclass = class_getSuperclass(class);
    if(superclass) {
      Method superclassMethod = class_getClassMethod(superclass, selector);
      if(superclassMethod) {
        return method == superclassMethod ? ZRMethodImplementationTypeSuper : ZRMethodImplementationTypeOverride;
      } else {
        return ZRMethodImplementationTypeImplement;
      }
    }
  }
  return ZRMethodImplementationTypeNotFound;  
}

NSString *NSStringFromZRMethodImplementationType(ZRMethodImplementationType type) {
  switch(type) {
    case ZRMethodImplementationTypeNotFound:  return @"ZRMethodImplementationTypeNotFound";
    case ZRMethodImplementationTypeImplement: return @"ZRMethodImplementationTypeImplement";
    case ZRMethodImplementationTypeOverride:  return @"ZRMethodImplementationTypeOverride";
    case ZRMethodImplementationTypeSuper:     return @"ZRMethodImplementationTypeSuper";
  }
  return nil;
}

