//
//  ZRModelConfiguration.h
//  AsyncDispatch
//
//  Created by ampatspell on 7/24/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "ZRRouteKind.h"
#import "ZRQueryKind.h"


@class ZRModelProperty, ZRRoute, ZRQuery;

@interface ZRModelConfiguration : NSObject {
  Class modelClass; 
  ZRModelConfiguration *superclassConfiguration;

  NSMutableArray *properties;
  NSMutableDictionary *propertiesForNames;
  NSMutableDictionary *routesForKinds;
  NSMutableDictionary *queriesForKinds;
}

- (id)initWithModelClass:(Class)modelClass superclassConfiguration:(ZRModelConfiguration *)superclassConfiguration;

@property(nonatomic, readonly, retain) ZRModelConfiguration *superclassConfiguration;

- (void)addProperty:(ZRModelProperty *)settings;
- (ZRModelProperty *)propertyForName:(NSString *)name;
@property(nonatomic, readonly, retain) NSArray *properties;

- (void)addRoute:(ZRRoute *)route;
- (ZRRoute *)routeForKind:(ZRRouteKind)kind;

- (void)addQuery:(ZRQuery *)query;
- (ZRQuery *)queryForKind:(ZRQueryKind)kind;

@end
