//
//  ZRModelState.h
//  AsyncDispatch
//
//  Created by ampatspell on 7/23/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


enum {
  ZRModelStateIdle       = 1 << 1,
  ZRModelStateError      = 1 << 2,
  ZRModelStateBusy       = 1 << 3,

  ZRModelStateDirty      = 1 << 4,

  ZRModelStateBlank      = 1 << 5,
  ZRModelStateNew        = 1 << 6,
  ZRModelStateCreated    = 1 << 7,
  ZRModelStateDestroyed  = 1 << 8,

  ZRModelStateLoading    = 1 << 9,
  ZRModelStateCreating   = 1 << 10,
  ZRModelStateUpdating   = 1 << 11,
  ZRModelStateDestroying = 1 << 12,
  
  ZRModelStateRetrying   = 1 << 13,
};

typedef int ZRModelState;


NSArray *NSArrayFromZRModelState(ZRModelState state);
NSString *NSStringFromZRModelState(ZRModelState state);

BOOL ZRModelStateHas(ZRModelState state, int value);
ZRModelState ZRModelStateAdd(ZRModelState state, int value);
ZRModelState ZRModelStateRemove(ZRModelState state, int value);
ZRModelState ZRModelStateReplace(ZRModelState state, int remove, int add);
