//
//  ZRModelState.m
//  AsyncDispatch
//
//  Created by ampatspell on 7/23/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ZRModelState.h"


BOOL ZRModelStateHas(ZRModelState state, int value) {
  return (state & value) != 0;
}

ZRModelState ZRModelStateReplace(ZRModelState state, int remove, int add) {
  state = ZRModelStateRemove(state, remove);
  state = ZRModelStateAdd(state, add);
  return state;
}

ZRModelState ZRModelStateAdd(ZRModelState state, int value) {
  state |= value;
  return state;
}

ZRModelState ZRModelStateRemove(ZRModelState state, int value) {
  state &= ~value;
  return state;
}

NSArray *NSArrayFromZRModelState(ZRModelState state) {
  NSMutableArray *array = [NSMutableArray array];
#define ZRModelStateAddFlag(flag) if(ZRModelStateHas(state, flag)) [array addObject:[NSString stringWithUTF8String:#flag]];
  ZRModelStateAddFlag(ZRModelStateIdle)
  ZRModelStateAddFlag(ZRModelStateError)
  ZRModelStateAddFlag(ZRModelStateBusy)
  
  ZRModelStateAddFlag(ZRModelStateDirty)
  
  ZRModelStateAddFlag(ZRModelStateBlank)
  ZRModelStateAddFlag(ZRModelStateNew)
  ZRModelStateAddFlag(ZRModelStateCreated)
  ZRModelStateAddFlag(ZRModelStateDestroyed)
  
  ZRModelStateAddFlag(ZRModelStateLoading)
  ZRModelStateAddFlag(ZRModelStateCreating)
  ZRModelStateAddFlag(ZRModelStateUpdating)
  ZRModelStateAddFlag(ZRModelStateDestroying)

  ZRModelStateAddFlag(ZRModelStateRetrying)
#undef ZRModelStateAdd
  return array;
}

NSString *NSStringFromZRModelState(ZRModelState state) {
  return [NSArrayFromZRModelState(state) componentsJoinedByString:@", "];
}
