//
//  ZROperation.h
//  AsyncDispatch
//
//  Created by ampatspell on 7/23/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface ZROperation : NSObject {
  NSString *action;
  NSDictionary *parameters;
  id target;
  SEL success;
  SEL failed;
  NSUInteger retryCount;
}

@property(nonatomic, readwrite, copy) NSString *action;
@property(nonatomic, readwrite, retain) NSDictionary *parameters;

@property(nonatomic, readwrite, retain) id target;
@property(nonatomic, readwrite) SEL success;
@property(nonatomic, readwrite) SEL failed;
@property(nonatomic, readwrite) NSUInteger retryCount;

- (void)incrementRetryCount;

- (void)performTargetSelector:(BOOL)success;

@end

@interface ZROperation (ZROperationAbstract)
- (void)didSucceedWithResult:(id)result;
- (void)didFailWithError:(NSError *)error;
@end
