//
//  ZRRPCOperation.h
//  ZeroEdit
//
//  Created by ampatspell on 6/4/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


extern NSString *const ZRRPCOperationErrorDomain;

extern NSInteger const ZRRPCOperationConnectionFailedErrorCode;
extern NSInteger const ZRRPCOperationInvalidJSONErrorCode;
extern NSInteger const ZRRPCOperationResponseStatusErrorCode;


@protocol ZRRPCOperationDelegate;

@interface ZRRPCOperation : NSOperation {
  BOOL executing_;
  BOOL finished_;
  
  NSURL *url_;
  NSDictionary *parameters_;
  
  NSURLConnection *connection_;
  NSMutableData *body_;
  NSInteger status_;
  
  id<ZRRPCOperationDelegate> delegate_;
  
  id userInfo_;
}

- (id)init;

@property(nonatomic, readwrite, copy) NSURL *url;
@property(nonatomic, readwrite, copy) NSDictionary *parameters;

@property(nonatomic, readwrite, assign) id<ZRRPCOperationDelegate> delegate;

@property(nonatomic, readwrite, retain) id userInfo;

@end

@protocol ZRRPCOperationDelegate
- (void)RPCOperation:(ZRRPCOperation *)operation didSucceed:(id)json;
- (void)RPCOperation:(ZRRPCOperation *)operation didFailWithError:(NSError *)error;
@end
