//
//  ZRRoute.h
//  AsyncDispatch
//
//  Created by ampatspell on 7/24/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "ZRRouteKind.h"
#import "ZRModelState.h"


@interface ZRRoute : NSObject {
  ZRRouteKind kind;
  NSString *path;
  
  ZRModelState busyState;
  ZRModelState successfulState;
  ZRModelState failedState;
  
  SEL successfulSelector;
  SEL failedSelector;
}

- (id)initWithKind:(ZRRouteKind)kind path:(NSString *)path;

@property(nonatomic, readonly) ZRRouteKind kind;
@property(nonatomic, readonly, retain) NSString *path;

@property(nonatomic, readonly) ZRModelState busyState;
@property(nonatomic, readonly) ZRModelState successfulState;
@property(nonatomic, readonly) ZRModelState failedState;

@property(nonatomic, readonly) SEL successfulSelector;
@property(nonatomic, readonly) SEL failedSelector;

@end
