//
//  ZRRoute.m
//  AsyncDispatch
//
//  Created by ampatspell on 7/24/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ZRRoute.h"


@interface ZRRoute ()
- (void)_prepare;
@end

@implementation ZRRoute
@synthesize kind, path, busyState, successfulState, failedState, successfulSelector, failedSelector;

- (id)initWithKind:(ZRRouteKind)aKind path:(NSString *)aPath
{
  if(self = [super init]) {
    kind = aKind;
    path = [aPath copy];
    [self _prepare];
  }
  return self;
}

- (void)dealloc
{
  [path release], path = nil;
  [super dealloc];
}

#pragma mark -

- (void)_prepare
{
  if(kind == ZRRouteKindLoad) {
    busyState       = ZRModelStateBusy | ZRModelStateLoading;
    successfulState = ZRModelStateCreated | ZRModelStateIdle;
    failedState     = ZRModelStateBlank | ZRModelStateIdle | ZRModelStateError;
    successfulSelector = @selector(didLoad);
    failedSelector     = @selector(loadDidFail);
  } else if(kind == ZRRouteKindCreate) {
    busyState       = ZRModelStateBusy | ZRModelStateCreating;
    successfulState = ZRModelStateCreated | ZRModelStateIdle;
    failedState     = ZRModelStateNew | ZRModelStateIdle | ZRModelStateError;
    successfulSelector = @selector(didCreate);
    failedSelector     = @selector(createDidFail);
  } else if(kind == ZRRouteKindUpdate) {
    busyState       = ZRModelStateBusy | ZRModelStateUpdating;
    successfulState = ZRModelStateCreated | ZRModelStateIdle;
    failedState     = ZRModelStateCreated | ZRModelStateIdle | ZRModelStateError;
    successfulSelector = @selector(didUpdate);
    failedSelector     = @selector(updateDidFail);
  } else if(kind == ZRRouteKindDestroy) {
    busyState       = ZRModelStateBusy | ZRModelStateDestroying;
    successfulState = ZRModelStateDestroyed | ZRModelStateIdle;
    failedState     = ZRModelStateCreated | ZRModelStateIdle | ZRModelStateError;
    successfulSelector = @selector(didDestroy);
    failedSelector     = @selector(destroyDidFail);
  }
}

@end
