//
//  ZRSingletonBoilerplate.h
//  ModelWithBacking
//
//  Created by ampatspell on 6/17/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//
//  http://developer.apple.com/DOCUMENTATION/Cocoa/Conceptual/CocoaFundamentals/CocoaObjects/chapter_3_section_10.html/
//
//  Usage:
//
//  @implementation Larry
//    ZR_SINGLETON_BOILERPLATE(Larry, sharedLarry)
//  @end
//

#define ZR_SINGLETON_BOILERPLATE(_className_, _accessorName_) \
  static _className_ *shared##_className_ = nil;              \
  + (_className_ *)_accessorName_                             \
  {                                                           \
    @synchronized(self) {                                     \
      if(shared##_className_ == nil) {                        \
        [[self alloc] init];                                  \
      }                                                       \
    }                                                         \
    return shared##_className_;                               \
  }                                                           \
                                                              \
  + (id)allocWithZone:(NSZone *)zone                                              \
  {                                                                               \
    @synchronized(self) {                                                         \
      if(shared##_className_ == nil) {                                            \
        shared##_className_ = [super allocWithZone:zone];                         \
        return shared##_className_;                                               \
      }                                                                           \
    }                                                                             \
    @throw [NSException exceptionWithName:@"SingletonAlreadyInitializedException" \
                                   reason:nil                                     \
                                 userInfo:nil];                                   \
  }                                                                               \
                                                                                  \
  - (id)copyWithZone:(NSZone *)zone \
  {                                 \
    return self;                    \
  }                                 \
                                    \
  - (id)retain                      \
  {                                 \
    return self;                    \
  }                                 \
                                    \
  - (NSUInteger)retainCount         \
  {                                 \
    return NSUIntegerMax;           \
  }                                 \
                                    \
  - (void)release                   \
  {                                 \
  }                                 \
                                    \
  - (id)autorelease                 \
  {                                 \
    return self;                    \
  }
