//
//  ZRZeroModel.m
//  AsyncDispatch
//
//  Created by ampatspell on 7/24/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ZRZeroModel.h"
#import "ZRCursorModelArray.h"


@implementation ZRZeroModel
@synthesize dispatch;

+ (void)prepare
{
  [self hasProperty:@"key"];
}

- (void)dealloc
{
  self.dispatch = nil;
  [super dealloc];
}

#pragma mark -

+ (BOOL)_hasSuccessStatus:(id)result error:(NSError **)error
{
  if([[result objectForKey:@"status"] isEqualToString:@"success"]) {
    return YES;
  }
  
  NSString *reason = [result objectForKey:@"reason"];
  NSDictionary *userInfo = [NSDictionary dictionaryWithObject:reason ? reason : @"Unknown Error" 
                                                       forKey:NSLocalizedDescriptionKey];
  
  *error = [NSError errorWithDomain:@"ZRSomeErrorDomain" code:10 userInfo:userInfo];
  return NO;
}

#pragma mark -

+ (NSDictionary *)parametersForModelArray:(id)array
{
  if([array isKindOfClass:[ZRCursorModelArray class]]) {
    NSMutableDictionary *dict = [NSMutableDictionary dictionary];
    NSString *cursor = [array cursor];
    if(cursor) {
      [dict setObject:cursor forKey:@"cursor"];
    }
    [dict setObject:[NSNumber numberWithUnsignedInteger:50] forKey:@"count"];
    return dict;
  }
  return nil;
}

+ (BOOL)isResultSuccessful:(id)result error:(NSError **)error forModelArray:(id)array
{
  if(![self _hasSuccessStatus:result error:error]) {
    return NO;
  }
  
  if([array isKindOfClass:[ZRCursorModelArray class]]) {
    [array setCursor:[result objectForKey:@"cursor"]];
  }
  
  return YES;
}

+ (NSArray *)dataArrayFromResult:(id)result
{
  return [result objectForKey:@"data"];
}

#pragma mark -

- (BOOL)isResultSuccessful:(NSDictionary *)result error:(NSError **)error
{
  return [[self class] _hasSuccessStatus:result error:error];
}

- (NSDictionary *)dataDictionaryFromResult:(NSDictionary *)result
{
  return [result objectForKey:@"data"];
}

@end
